/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package sharemarketmdb;

import javax.ejb.ActivationConfigProperty;
import javax.ejb.MessageDriven;
import javax.ejb.MessageDrivenContext;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.*;

/**
 *
 * @author Dhaval
 */
@MessageDriven(mappedName = "ShareMarket/tTopic", activationConfig =  {
        @ActivationConfigProperty(propertyName = "acknowledgeMode", propertyValue = "Auto-acknowledge"),
        @ActivationConfigProperty(propertyName = "destinationType", propertyValue = "javax.jms.Topic"),
        @ActivationConfigProperty(propertyName = "subscriptionDurability", propertyValue = "Durable"),
        @ActivationConfigProperty(propertyName = "clientId", propertyValue = "MessageDrivenBeanBean"),
        @ActivationConfigProperty(propertyName = "subscriptionName", propertyValue = "MessageDrivenBeanBean")
    })
public class MessageDrivenBeanBean implements MessageListener {
    
    private MessageDrivenContext mdc;
    
    
    public MessageDrivenBeanBean() {
    }

    public void onMessage(Message message) 
    {
        AccountBean database=new AccountBean();
        TextMessage msg = null;
        try 
        {
            if (message instanceof TextMessage)
            {
                msg = (TextMessage) message;
                int tid=Integer.parseInt(msg.getText());
                System.out.println("Transaction ID: " + tid);
                        
                database.update(tid);
            } 
            else
            {
               System.out.println("Message of wrong type: " +
                        message.getClass().getName());
                
            }
        }
        catch (JMSException e) 
        {
            e.printStackTrace();
            mdc.setRollbackOnly();
        }
        catch (Throwable te) 
        {
            te.printStackTrace();
        }


    }
    
}
